import React from 'react';
import { AmauiTheme } from '@amaui/style';
import { IAmauiTheme } from '@amaui/style/amaui-theme';
export interface IAmauiThemeProviderValue extends AmauiTheme {
    updateWithRerender: (value: IAmauiTheme) => AmauiTheme;
}
interface IAmauiThemeProvider extends React.HTMLAttributes<any> {
    root?: boolean;
    value?: IAmauiTheme;
    children?: any;
}
declare const AmauiThemeProvider: React.ForwardRefExoticComponent<IAmauiThemeProvider & React.RefAttributes<unknown>>;
export default AmauiThemeProvider;
