import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
const _excluded = ["children", "className"];
import React from 'react';
import { classNames } from '@amaui/style';
import { style } from '.';

const styled = Element => function (value) {
  var _Element$type;

  let options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  // Name
  options.name = options.name !== undefined ? options.name : "".concat((Element === null || Element === void 0 ? void 0 : Element.displayName) || (Element === null || Element === void 0 ? void 0 : (_Element$type = Element.type) === null || _Element$type === void 0 ? void 0 : _Element$type.displayName) || '', "Styled"); // Use styles

  const useStyle = style(value, options); // Element

  const element = /*#__PURE__*/React.forwardRef((props, ref) => {
    const {
      children,
      className: classNameProp
    } = props,
          other = _objectWithoutProperties(props, _excluded);

    const styles = useStyle(props);
    return /*#__PURE__*/React.createElement(Element, _extends({
      ref: ref,
      className: classNames([classNameProp, styles.class])
    }, other), children);
  });
  return element;
};

export default styled;